--##****************************************************
--##****************************************************
--##**	   TURRET DEFENCE		             **
--##**	              SCRIPT  BY SAYA                            **
--##**		    MAP BY CLEOPATRE                     **
--##**	                   V 1.1 ALPHA                                       **
--##****************************************************



--scenario utilities
local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local Utilities = import('/lua/utilities.lua')
local EffectUtil = import('/lua/EffectUtilities.lua')

ScenarioInfo.Options.FogOfWar = 'none'

--add an ondamage callback
--[[
do
	local Unit = import('/lua/sim/unit.lua').Unit
	local OldOnDamage = Unit.OnDamage
	Unit.OnDamage = function(self, instigator, armormod, direction, damagetype)
	    OldOnDamage(self, instigator, armormod, direction, damagetype)
		WARN("LOL")
		--add an ondamage callback
		if self and instigator and not self:IsDead() then
			if instigator.slowdown then
				doSlowDown(self,instigator,instigator.slowdown.percent,instigator.slowdown.time)
			end
		end
	end 
end
--]]


--PLAYERS, CONTAINS USEFUL INFO FOR THE SCRIPT FOR EACH PLAYER
local playersDATA = {
	['player1'] = {
		name = 'player1', 
		defeated = false,
		enemy = 'enemy',
		upgrader = false,
		ai = false,
		kills = 0,
		credits = 0,
	},
	['player2'] = {
		name = 'player2', 
		defeated = false,
		enemy = 'enemy',
		upgrader = false,
		ai = false,
		kills = 0,
		credits = 0,
	},
	['player3'] = {
		name = 'player3',
		defeated = false,
		enemy = 'enemy',
		upgrader = false,
		ai = false,
		kills = 0,
		credits = 0,
	},
	['player4'] = {
		name = 'player4', 
		defeated = false,
		enemy = 'enemy',
		upgrader = false,
		ai = false,
		kills = 0,
		credits = 0,
	},
	['enemy'] = {
		name = 'enemy', 
		defeated = false,
		ai = true,
		color = {141,96,255},
	},
	['neutral'] = {
		name = 'neutral',
		defeated = false,
		ai = true,
		color = {255,84,50},
	},
}

local players = {}

local armyTable = {
	 ['ARMY_1'] = 'player1',
	 ['ARMY_2'] = 'player2',
	 ['ARMY_3'] = 'player3',
	 ['ARMY_4'] = 'player4',
	 ['ARMY_9'] = 'enemy',
	 ['ARMY_10'] = 'neutral',
}


--scenario variables
local gameEnd = false
local waveEnd = false
local executing = false
local beatTime = 2
local beat = 0
local waveid = 1
local loop = 0
local lifeUnits = false


--map size
local xmapsize = ScenarioInfo.size[1]
local ymapsize = ScenarioInfo.size[2]
local mapHeight = 64
local mapRect = {x0 = 0, x1 = xmapsize, y0 = 0, y1 = ymapsize}


--units move from area to area
local areas = {}
--map editor markers
--units will move from area to area, an area is created with each marker of the markers table
local markers = {
	"Start",
	"Step1",
	"Step2",
	"Step3",
	"Step4",
	"Step5",
	"Step6",
	"Step7",
	"Finish",	
}


--game variables
local buildTime = 30
local lives = 42
local defaultincome = 1

--only AA and PDs will be buildable
local buildRestriction = categories.ALLUNITS - categories.DEFENSE*(categories.DIRECTFIRE+categories.ANTIAIR)
--only AA will be buildable
local AAONLYbuildRestriction = categories.ALLUNITS - categories.STRUCTURE*categories.ANTIAIR 


--first parameter of a wave is duration in seconds, it is the time before the next wave
--second parameter is the composition of the wave, it is made up of one to many unit sets
--the first parameter of a unit set is the unittype, the second is the number of units 
--upgrades is used for scus to spawn a scu with upgrades
--speed is  a speed multiplayer to be applied to a unit, default is 1
--health is to specify unit health, default is the Blueprint value
--income is the money you win by killing the unit, default value is defaultincome
--boss is for special units: boss =  1  enable weapons, boss  = 2 ignore damage callbacks, boss = 3 do both
--bonus is the money each player will get after completing a round (successfully, without losing a life? - up to debate)
local waves = {
	{duration = 80, bonus = 20, composition = {{'URA0401',16, health = 30},},},
	{duration = 60, bonus = 20, composition = {{'UAA0103',6,speed = 0.3,health = 260},},},
	{duration = 60, bonus = 20, composition = {{'URA0103',20,speed = 0.6,health = 45},},},
	{duration = 60, bonus = 20, composition = {{'UEA0103',30,speed = 0.8,health = 65},},},
	{duration = 60, bonus = 20, composition = {{'UAA0103',32,speed = 0.8,health = 135},},},
	{duration = 60, bonus = 20, composition = {{'URA0103',24,speed = 0.7,health = 220},},},
	{duration = 60, bonus = 30, composition = {{'UEA0103',25,speed = 0.7,health = 310},},},
	{duration = 60, bonus = 30, composition = {{'UEA0305',40,speed = 0.3,health = 770},},},
	{duration = 90, bonus = 60, composition = {{'uea0304',1,speed = 0.2,health = 35000, boss = 1, income = 50},},},
	{duration = 70, bonus = 30, composition = {{'ura0203',25,speed = 0.8,health = 610},},},
	{duration = 60, bonus = 30, composition = {{'ura0204',40,speed = 0.4,health = 1100},},},
	{duration = 60, bonus = 30, composition = {{'ura0101',2,speed = 1.4,health = 1700, income = 50},},},
	{duration = 60, bonus = 30, composition = {{'ura0304',32,speed = 0.6,health = 2120},},},
	{duration = 60, bonus = 30, composition = {{'URA0401',10,speed = 0.9,health = 4200},},},
	{duration = 60, bonus = 30, composition = {{'uea0104',20,speed = 0.7,health = 3400},},},
	{duration = 60, bonus = 30, composition = {{'uaa0304',40,speed = 0.6,health = 1470},},},
	{duration = 60, bonus = 30, composition = {{'uea0101',35,speed = 1.1,health = 600},},},
	{duration = 60, bonus = 30, composition = {{'ura0302',40,speed = 0.5,health = 3400},},}, 
	{duration = 120, bonus = 100, composition = {{'uaa0310',1,speed = 1.1,health = 200000, boss = 1, income = 50},},},
	{duration = 80, bonus = 40, composition = {{'ura0107',16,speed = 0.2, health = 3500},},},
	{duration = 60, bonus = 40, composition = {{'ura0103',6,speed = 0.3,health = 2600},},},
	{duration = 60, bonus = 40, composition = {{'UEA0103',20,speed = 0.6,health = 2500},},},
	{duration = 60, bonus = 40, composition = {{'UAA0103',30,speed = 0.8,health = 3500},},},
	{duration = 60, bonus = 40, composition = {{'URA0103',32,speed = 0.8,health = 1350},},},
	{duration = 60, bonus = 40, composition = {{'UEA0103',24,speed = 0.7,health = 2200},},},
	{duration = 60, bonus = 60, composition = {{'UAA0103',25,speed = 0.7,health = 3100},},},
	{duration = 60, bonus = 60, composition = {{'uea0204',40,speed = 0.2,health = 7700},},},
	{duration = 90, bonus = 150, composition = {{'ura0304',1,speed = 0.2,health = 35000, boss = 1, income = 100},},},
	{duration = 70, bonus = 50, composition = {{'uea0203',25,speed = 0.8,health = 6100},},},
	{duration = 60, bonus = 50, composition = {{'uea0204',40,speed = 0.4,health = 11000},},},
	{duration = 60, bonus = 50, composition = {{'uea0101',2,speed = 1.4,health = 17000, income = 100},},},
	{duration = 60, bonus = 50, composition = {{'uaa0304',32,speed = 0.6,health = 21200},},},
	{duration = 60, bonus = 50, composition = {{'ura0104',10,speed = 0.3,health = 42000},},},
	{duration = 60, bonus = 50, composition = {{'ura0104',20,speed = 0.7,health = 34000},},},
	{duration = 60, bonus = 50, composition = {{'ura0304',40,speed = 0.6,health = 14700},},},
	{duration = 60, bonus = 50, composition = {{'uaa0101',35,speed = 1.1,health = 6000},},},
	{duration = 60, bonus = 50, composition = {{'uea0302',40,speed = 0.5,health = 34000},},}, 
	{duration = 120, bonus = 200, composition = {{'uaa0310',1,speed = 1.3,health = 800000, boss = 1, income = 50},},},	
}

--the turrets table allows to simply parameter the available turrets
--price = value
--damage = value
--poison = {damage,time}
--slowdown = {percent,time}
--for poison and slowdown towers only
--area: area of effect around the target
--weaponsfired: selects how many weapons will fire
local turrets = {
  --t1 AA
	{bpid = 'ueb2104', price = 5, damage = 7},
	{bpid = 'uab2104', price = 10, damage = 18},
	{bpid = 'urb2104', price = 30, damage = 64},
	--t2 AA
	{bpid = 'ueb2204', price = 10, damage = 5},
	{bpid = 'uab2204', price = 20, damage = 26},
	{bpid = 'urb2204', price = 70, damage = 52},
	--t3 AA
	{bpid = 'ueb2304', price = 10, damage = 9},
	{bpid = 'uab2304', price = 20, damage = 23},
	{bpid = 'urb2304', price = 70, damage = 90},
	--t1 PD
	{bpid = 'ueb2101', name = 'slowdown lvl 1', price = 15, damage = 3, slowdown = {75,10}, area = 3},
	{bpid = 'uab2101', name = 'slowdown lvl 2', price = 30, damage = 3, slowdown = {60,20}, area = 5},
	{bpid = 'urb2101', name = 'slowdown lvl 3', price = 120, damage = 3, slowdown = {50,60}, area = 7},
	--t2 PD
	{bpid = 'ueb2301', name = 'poison lvl 1', price = 15, damage = 5, poison = {2,30}, weaponsfired = 1, area = 1},
	{bpid = 'uab2301', name = 'poison lvl 2', price = 30, damage = 40, poison = {4,60}, area = 2},
	{bpid = 'urb2301', name = 'poison lvl 3', price = 100, damage = 120, poison = {16,90},  weaponsfired = 1, area = 3},
}

--determines how much kills are needed to get a credit
local creditKillCost = 23

--shop mass/credit cost tables
local shopPrices = {
	mobileAA = 1,
	interceptor = 1,
	poisonAA = 2,
	freezeAA = 2, 
	mass100 = 1,
	lives5 = 1,
	UEFbuilder = 5,
	AEONbuilder = 60,
	CYBRANbuilder = 120,
}




--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~MAIN SCRIPT FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

import('/lua/SimUtils.lua').GiveUnitsToPlayer = function() end	
import('/lua/SimUtils.lua').SetResourceSharing = function() end

--populating
function OnPopulate()	
	InitializeArmies()
    ScenarioFramework.SetPlayableArea('playarea', false)	
end


--start of map script
function OnStart(self)

	-- force victory condition to sandbox
	--ScenarioInfo.Options.Victory = 'demoralization'
	ScenarioInfo.Options.Victory = 'sandbox'
	
	-- set score calculation to show player credits
	for index, brain in ArmyBrains do
	   brain.CalculateScore = function(thisBrain)
			local player = players[ArmyIndexer(thisBrain)]
			local score = 0
			
			if player.ai == false then
				score = players[ArmyIndexer(thisBrain)].credits
			else
				score = beat
			end
			
			return score 
	   end
	end 
	
   
	--initialise scenario
	Utilities.UserConRequest("ui_ForceLifbarsOnEnemy")--show enemy life bars
	allReclaimablesOFF()
	initAreas()
	initShops()
	spawnStartUnits()
	 
	--start the different scenario threads
	startScenarioThreads()
end



--creates the different threads 
startScenarioThreads = function()

	--init thread
	local initThread = ForkThread(function(self)
		WaitSeconds(1)
		for index, player in players do 
			local brain = GetArmyBrain(toArmy(player))
			local mass = brain:GetEconomyStored('MASS')
			local startmoney = 30
			local energy = brain:GetEconomyStored('ENERGY')
			SetArmyEconomy( toArmy(player), -mass + startmoney , 0)		
			brain:GiveStorage('MASS', 1600)			
		end
			KillThread(self)
	end)
	
	--start main thread
	local mainThread = ForkThread(function(self)
		while gameEnd == false do
			--wait time between each beat
			WaitSeconds(beatTime)
			--call main thread beat
			if executing == false then
				executing = true
				mainThreadBeat()
			end
			executing = false
			--increment beat count
			beat = beat + 1
		end
		KillThread(self)
    end)
	
	--check for upgrade request thread
	local checkThread = ForkThread(function(self)
		while gameEnd == false do 
			WaitSeconds(1)
			checkUpgradeRequests()
		end
		KillThread(self)
	end)
	
	--spawning a new wave only depends on time
	--this creates a new thread for each human  player
	local spawnThread = ForkThread( function(self)
		--some time to let everybody build up  a little
		countDown(buildTime)
		
		--start sending the waves!
		while gameEnd == false do 
			while waveEnd == false do
			
				--if the wave exists
				if waveid <= table.getn(waves) and gameEnd == false then

					--spawn wave				
					spawnWave()						

					--wait time until next wave
					countDown(getWave().duration)

					--give end of wave money bonus
					wavebonus()
					
					--go to next wave
					waveid = waveid+1
					
				else
					waveEnd = true
				end
			
			end
		--game never ends, once all rounds are done increase difficulty and restart rounds
		waveid = 1
		loop = loop + 1
		waveEnd = false
		end
		
		--no more waves to send, kill thread
		KillThread(self)
	end)
	
	

end

--main thread beat
mainThreadBeat = function()
	streamUnits()	
	updateDATA()
end

--move units in areas to the next area
streamUnits = function()
	for index,area in areas do
	
		--get units in area
		local unitsInArea = false
		
		if area.startarea or area.finalarea then
			unitsInArea = GetUnitsInRect(area)
		else
			unitsInArea = GetUnitsInRect(processedArea(area))
		end
		
		local aiAreaUnits = {}
		
		--if the area contains units
		if unitsInArea and unitsInArea != false and table.getn(unitsInArea) > 0 then			
			for index, unit in unitsInArea do
				local player = players[armyTable[scnArmy(unit)]]
				if player.ai == true then
					table.insert(aiAreaUnits,unit)
				end			
			end
		end
		
		--if the area contains enemy units
		if table.getn(aiAreaUnits) > 0 then
			--if not last area move unit
			if area.finalarea != true  then
				local nextArea = areas[index+1]
				local targetCenter = areaCenter(nextArea)
				local targetLocation = {targetCenter[1],mapHeight,targetCenter[2]}
				--IssueClearCommands( aiAreaUnits ) --was useful for land units but for air it was actually bad, commenting it fixed a few pathing issues
				IssueMove( aiAreaUnits, targetLocation ) 				
			--if last area remove lives
			else
				for index,unit in unitsInArea do
					--kill unit if not neutral
					if toPlayer(scnArmy(unit)).name  != players['neutral'].name then
						unit:Kill()
					end
					--remove life if enemy
					if toPlayer(scnArmy(unit)).name  == players['enemy'].name then
						removeLife()
					end
				end
			end
		end
	end
end

--makes a player lose a life and checks for defeat conditions
removeLife = function(player)

	--remove a life
	if lives > 0 then
		lives = lives - 1		

		--kill life unit		
		local unit = lifeUnits[lives+1]
		unit:SetCanBeKilled(true)
		unit:Kill()

		
		fastPrint("You lost a life, " .. lives .. " lives remaining")	
		
		--check defeat conditions
		if lives == 0 then		
			fastPrint("The miserable humans have been defeated at level " .. waveid)
			gameEnd = true
			local defeatThread = ForkThread(function(self)
				WaitSeconds(5)	
				for index, player in players do
					GetArmyBrain(toArmy(player)):OnDefeat()
				end		
				KillThread(self)
			end)
		end				
	end	

end

--adds a life and creates a life building
addLife = function()
	lives = lives + 1
	--create life building
	local n = lives - 1
	WARN(repr(lifeUnits.data))
	local x = lifeUnits.data.rectangle.x0 + lifeUnits.data.interval *  math.ceil(n,lifeUnits.data.jmax)
	local y = lifeUnits.data.rectangle.y0 + lifeUnits.data.interval * math.mod(n,lifeUnits.data.imax)
	unit = CreateUnitHPR( lifeUnits.data.unitType, lifeUnits.data.army, x, mapHeight, y, 0,0,0) 
	unit:GetBlueprint().Wreckage.WreckageLayers.Land=false
	makeInvincible(unit)
	table.insert(lifeUnits,unit)
end



--data update for script ai
updateDATA = function()
	copyPlayerInfo()
end













--~~~~~~~~~~~~~~~~~~~~~~~~~~~~AREA MANAGEMENT~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--given an area returns its center
areaCenter = function(area)
	local x = (area.x0 + area.x1)/2
	local y = (area.y0 + area.y1)/2
	return {x,y}
end

--given an area returns the central part of this area
processedArea = function(area)
	local areaWidth = math.abs(area.x1 - area.x0)
	local areaHeight = math.abs(area.y1 - area.y0)
	local center = areaCenter(area)
	local xa = center[1] - areaWidth/2
	local ya = center[2] - areaHeight/2
	local xb = center[1] + areaWidth/2
	local yb = center[2] + areaHeight/2
	return {x0 = xa, y0 = ya, x1 = xb, y1 = yb}	
end

--initialise areas
initAreas = function()
	for index, markername in markers do
		local area = markerToRect(markername)
		table.insert(areas,area)
	end
end















--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~WAVE MANAGEMENT~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--returns the current wave
getWave = function()
	return waves[waveid]
end

--give wave bonus
wavebonus = function()
	local bonus = getWave().bonus
	if bonus then 
		for index,player in players do
			local army = toArmy(player)
			SetArmyEconomy( army, bonus, 0)
		end
	end
end


--spawn the current wave
spawnWave = function()
	local player = players['enemy']
	local wave = getWave()
	local aiBrain = GetArmyBrain(toArmy(player))
	local spawnRectangle = processedArea(markerToRect("Start"))
	
	if wave != false then	
		fastPrint("Prepare for wave " .. waveid .. "!")
		
		local j = 1
		for index,unitset in wave.composition do
			local i = 1
			local numberOfUnits = math.ceil(unitset[2]*(1 + (playerCount() - 1)*20/100))
			
			--spawn units
			while i <= numberOfUnits do	
				local x = spawnRectangle.x0
				local y = spawnRectangle.y0 + j*5
				
				--calculate formation position of unit
				local rowposition = math.mod(i,8)*5
				local lineposition = math.ceil(i/8)*5
				
				--spawn unit
				local unit = false
				if GetArmyUnitCostTotal(GetArmyBrain(toArmy(player)):GetArmyIndex()) < GetArmyUnitCap(GetArmyBrain(toArmy(player)):GetArmyIndex()) then
					unit = CreateUnitHPR( unitset[1], toArmy(player), rowposition + x, mapHeight, lineposition + y, 0,0,0) 
				end
				
				if unit != false then
					--play spawn effect
					spawnEffect(unit)
					
					--disable wreckage, necessary or you could get many turrets for the price of one
					unit:GetBlueprint().Wreckage.WreckageLayers.Land=false
					
					--if its a boss type = 1 enable weapons, type = 2 ignore damage callbacks, type3 = doboth
					--else disable all weapons and add damage callbacks
					if unitset.boss then
						if unitset.boss == 1 then
							addDamagedCallBack(unit)
						end
					else
						unit:SetAllWeaponsEnabled(false)						
						addDamagedCallBack(unit)
					end
					
					--give money for kills
					if unitset.income then
						addKillerIncome(unit,unitset.income,0)	
					else
						addKillerIncome(unit,1,0)	
					end
					
					--apply upgrades if necessary
					if unitset.upgrades then 
						for i,enhancement in unitset.upgrades do
							unit:CreateEnhancement(enhancement)
						end
					end
					
					--specify speed
					if unitset.speed then
						unit:SetSpeedMult( unitset.speed )
						unit.originalSpeedmult = unitset.speed 
					end
					
					--specify health
					if unitset.health then	
						local health = unitset.health*(1 + (playerCount() - 1)*65/100)
						unit:SetMaxHealth(health)
						unit:SetHealth(nil,health)
					end
					
					--apply buffs for looped rounds
					if loop > 0 then
						unit:SetMaxHealth(unit:GetHealth()*12*loop)
						unit:SetHealth(nil,unit:GetHealth()*12*loop)
					end
				end
				
				i = i + 1
			end
			j = j + 1
		end		
		

	end
	
end














--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~UNIT SPAWNING MANAGEMENT~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--spawn the start buildings, life count buildings and shops
spawnStartUnits = function()
	--spawn life buildings
	local neutral = players['neutral']
	local neutralArmy = toArmy(neutral)
	spawnrect = ScenarioUtils.AreaToRect('Finish_area')
	lifeUnits = spawnInRectangle(spawnrect,neutralArmy,'UEC1101',8,lives)
	
	--spawn ACUs	
	for index, player in players do
		if player.ai == false then
			createBuilder(player)			
			respawnUpgrader(player)
		end
	end

end

--advanced function to spawn a certain number of a certain type of unit for a certain player inside a rectangle
--with a given interval and a maximum number of units
spawnInRectangle = function(rectangle,army,unitType,interval,maxunits)
	local units = {}
	
	local width = rectangle.x1 - rectangle.x0
	local height = rectangle.y1 - rectangle.y0
	
	local imax = math.floor(width/interval)
	local jmax = math.floor(height/interval)
	
	local unitsSpawned = 0
	
	--spawn units in rectangle within limit
	for i = 1,imax do
		for j = 1,jmax do				
			if unitsSpawned < maxunits then
				local x = rectangle.x0 + i*interval
				local y = rectangle.y0 + j*interval
				unit = CreateUnitHPR( unitType, army, x, mapHeight, y, 0,0,0) 
				unit:GetBlueprint().Wreckage.WreckageLayers.Land=false
				makeInvincible(unit)
				table.insert(units,unit)
				unitsSpawned = unitsSpawned + 1
			end
		end
	end
	
	units.data = {army = army,unitType = unitType,interval = interval,maxunits = maxunits,unitsSpawned = unitsSpawned,imax = imax,jmax = jmax,width = width,height = height, rectangle = rectangle}
	
	return units or {}
end


--spawn unit at start position
spawnUnit = function(player,bpid)
	unit = CreateUnitHPR( bpid, toArmy(player),mPos(toArmy(player))[1], mPos(toArmy(player))[2],mPos(toArmy(player))[3], 0,0,0) 
	spawnEffect(unit)
	return unit
end

--spawn basic builder unit
createBuilder = function(player,bpid)
	if player.ai == false then
		local builder = false
		if bpid then 
			builder = spawnUnit(player,bpid)	
		else
			builder = spawnUnit(player,'uel0301')		
		end		
		makeBuilder(player,builder)
	end
end













--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~SHOP AND REQUEST MANAGEMENT FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~

--~~~~Particular shop behaviour~~~~

--list of all shops with their callback functions
local shops = {
	
	{name = 'shop1', description = 'Mobile AA : 1 Point', bpid = 'uel0205', buy = function(player) buyMobileAA(player,shopPrices.mobileAA) end},	
	
	{name = 'shop2', description = 'Short-Term Interceptor : 1 Point', bpid = 'uab5202', buy = function(player) buyPerishable(player,shopPrices.interceptor)	end},
	
	{name = 'shop5', description = 'Poison Mobile AA : 2 Points', bpid = 'url0205', buy = function(player) buyPoisonAA(player,shopPrices.poisonAA) end},
	
	{name = 'shop4', description = 'Exchange for Mass : 1 Point' , bpid = 'ueb1302', buy = function(player) buyMass(player,shopPrices.mass100) end},
	
	--{name = 'shop3', description = '5 Lives : 2 Points', bpid = 'UEC1101', buy = function(player) buylives(player,shopPrices.lives5,5) end},
	
	{name = 'shop6', description = 'Freeze Mobile AA : 2 Points', bpid = 'ual0205', buy = function(player) buyFreezeAA(player,shopPrices.freezeAA) end},
	
	{name = 'shopUEF', description = 'T1 UEF Engineer : 5 Mass', bpid = 'ueb1301', buy = function(player)  buyBuilder(player,shopPrices.UEFbuilder,'UEF') end},
	
	{name = 'shopAEON', description = 'T2 AEON Engineer : 60 Mass', bpid = 'uab1301', buy = function(player) buyBuilder(player,shopPrices.AEONbuilder,'AEON') end},
	
	{name = 'shopCYBRAN', description = 'T3 CYBRAN Engineer : 120 Mass', bpid = 'urb1301', buy = function(player) buyBuilder(player,shopPrices.CYBRANbuilder,'CYBRAN') end},
	
}


--mobile AA shop
buyMobileAA = function(player,price)
	if checkPrice(player,price,"credits") then 
		unit = spawnUnit(player,'uel0205')
		fastPrint(username(player) .. ' bought a mobile AA') 
	else 
		fastFocusPrint('Not enough credits for mobile AA',player)
	end
end

--freeze mobile aa
buyFreezeAA = function(player,price)
	if checkPrice(player,price,"credits") then 
		unit = spawnUnit(player,'ual0205') 
		fastPrint(username(player) .. ' bought a freeze AA') 
		addSlowDown(unit,60,60)
		for i = 1, unit:GetWeaponCount() do
			setDamage(unit:GetWeapon(i),1)
			unit:GetWeapon(i):ChangeRateOfFire(1)
		end
	else 
		fastFocusPrint('Not enough credits for freeze AA',player)
	end
end


--poison mobile aa
buyPoisonAA = function(player,price)
	if checkPrice(player,price,"credits") then 
		unit = spawnUnit(player,'url0205') 
		fastPrint(username(player) .. ' bought a Poison AA') 
		addPoison(unit,10,60)
		for i = 1, unit:GetWeaponCount() do
			setDamage(unit:GetWeapon(i),1)
			unit:GetWeapon(i):ChangeRateOfFire(1)
		end
	else 
		fastFocusPrint('Not enough credits for Poison AA',player)
	end
end
	
--perishable interceptor shop
buyPerishable = function(player,price)
	if checkPrice(player,price,"credits") then 
		fastPrint(username(player) .. ' bought an Interceptor') 
		unit = spawnUnit(player,'uaa0303') 
		makePerishable(unit,180) 
		for i = 1, unit:GetWeaponCount() do
			unit:GetWeapon(i):AddDamageMod(550)
		end
		
	else
		fastFocusPrint('Not enough credits the Interceptor',player)
	end
end

--mass shop
buyMass = function(player,price)
	if checkPrice(player,price,"credits") then 
		SetArmyEconomy( toArmy(player), 50  , 0)	 
		fastPrint(username(player) .. ' bought 50 mass for 1 credit') 
	else
		fastFocusPrint('Not enough credits to buy mass',player)
	end
end

--buy lives
buylives = function(player,price,number)
	
	if lives <= 37 then
		if checkPrice(player,price,"credits") then 
			fastPrint(username(player) .. ' bought lives for the team')
			for i = 1,number do
				addLife()
			end
		else
			fastFocusPrint('Not enough credits to buy lives',player)
		end
	else
		fastPrint("You can't have more than 42 lives ... buy some when your in real need")
	end
end

--buy engineer
buyBuilder = function(player,price,faction)
	
	local bpid = false
	
	if faction == 'UEF' then
		bpid = 'uel0301'
	elseif faction == 'AEON' then
		bpid = 'ual0301'
	elseif faction == 'CYBRAN' then
		bpid = 'url0301'
	end
	
	if bpid != false then
		if checkPrice(player,price) then 
			createBuilder(player,bpid) 
			fastPrint(username(player) .. ' bought a ' .. faction .. ' builder!')
		else
			fastFocusPrint('Not enough mass to buy ' .. faction .. ' builder',player)
		end
	end
end


--~~~~Global Shop Management~~~~

--initialise all shops
initShops = function()
	for index, shop in shops do
		if GetMarker(shop.name) then
			local pos = mPos(shop.name)
			local neutral = toArmy(players['neutral'])

			--use unit type or default
			if shop.bpid then
				shop.unit = CreateUnitHPR( shop.bpid, neutral, pos[1], pos[2], pos[3], 0,0,0) 
			else
				shop.unit = CreateUnitHPR( 'ueb5202', neutral, pos[1], pos[2], pos[3], 0,0,0) 
			end
			
			--use shop description or default
			if shop.description then
				shop.unit:SetCustomName(shop.description)
			else
				shop.unit:SetCustomName(shop.name)
			end
			
			--make shope invincible
			shop.unit:SetAllWeaponsEnabled(false)		
			shop.unit:SetCanBeKilled(false)
			shop.unit:SetDoNotTarget(true)
			shop.unit:SetMaxHealth(1)
			shop.unit:SetHealth(nil,1)
			shop.unit:SetRegenRate(1)
			shop.unit:SetUnSelectable(true)
			shop.unit:SetImmobile(true)
		else
			shop.unit = false
		end
	end
end

--checks all shops for each players
checkUpgradeRequests = function()
	for index, shop in shops do 
		checkShop(shop)
	end
end

--check if there is a shop request and do the corresponding action if the check is positive
checkShop = function(shop)
	if shop.unit != false then	
		for index,player in players do
			if player.upgrader then
				--get target data
				local v1 = player.upgrader:GetNavigator():GetGoalPos()
				local v2 = shop.unit:GetPosition()
				local check = {false,false,false}
				local tolerance = 10
				
				--verify if target is inside range
				for i = 1,3 do
					if math.abs(v1[i] - v2[i]) <= tolerance then
						check[i] = true
					end
				end

				--if check is ok do shop action
				if check[1] == true and check[3] == true then --and check[2] == true --ignoring vertical checking			   
					ForkThread(function() playBuildEffect(shop.unit) end)					
					respawnUpgrader(player)
					shop.buy(player)
				end
			end
		end
	end
end


--kill and respawn player upgrader  unit
respawnUpgrader = function(player)
	
	--calculate spawn position
	local armyNumber = string.gsub(toArmy(player),'ARMY_(.*)','%1')
	local position = mPos('upgrader' .. armyNumber) 
	local xPos = position[1]
	local zPos = position[2]
	local yPos = position[3]

	--destroy upgrader unit if necessary
	if player.upgrader != false then
		player.upgrader:SetCanBeKilled(true)
		player.upgrader:Kill()
		player.upgrader = false
	end	
	--spawn upgrader unit
	if player.upgrader == false then 
		player.upgrader = CreateUnitHPR( 'uec0001', toArmy(player), xPos,zPos,yPos, 0,0,0)
		player.upgrader:GetBlueprint().Wreckage.WreckageLayers.Land=false		
		player.upgrader:SetAllWeaponsEnabled(false)	
		player.upgrader:SetCanBeKilled(false)
		player.upgrader:SetDoNotTarget(true)
		player.upgrader:SetMaxHealth(1)
		player.upgrader:SetHealth(nil,1)
		player.upgrader:SetRegenRate(1)
		player.upgrader:SetSpeedMult(2)
		player.upgrader:SetAccMult(10)       
        --player.upgrader:SetTurnMult(10)
		player.upgrader:SetCustomName(username(player) .. ': business man')
	end
end















--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~INSTABUILD MANAGEMENT FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



--given a bpid returns the turret info
getTurret = function(bpid)
	local turret = false
	for i,t in turrets do
		if t.bpid == bpid then
			turret = t
		end
	end
	return turret
end


--add instabuild to a unit
addInstaBuild = function(unit)
	--modify the behavior of the unit when it starts to build a unit
	unit.OnStartBuild = function(self, unitbuilding, order)		
		local bp = unitbuilding:GetBlueprint()
		local bpid = bp.BlueprintId
		local turret = getTurret(bpid)
		
		--create nice build beam effects
		local builderEffectsThread = ForkThread(function(self)
			if unit and unitbuilding then
				EffectUtil.CreateDefaultBuildBeams( unit, unitbuilding, unit.BuildBones.BuildEffectBones, unit.BuildEffectsBag )
			end
			--unit.StopBuildingEffects(self, self:GetUnitBeingBuilt())
			KillThread(self)
		end)	
		
		
		--build unit
		instaBuild(unitbuilding,turret)
		
	end
	
end

--pass a builder unit and a price in parameter to build a building
instaBuild = function(unit,turret)
	
	--get original unit data
	local pos = unit:GetPosition()
	local bp = unit:GetBlueprint()
	local bpid = bp.BlueprintId
	local army = scnArmy(unit)
	local brain = GetArmyBrain(army)
			
				
	--build thread
	local buildThread = ForkThread(function(self)
		local unitbuilt = false
		while unitbuilt == false do
			WaitSeconds( 0.1 )
			if brain:GetEconomyStored('MASS') >= turret.price then	
		
				--insta build unit				
				local newunit = CreateUnitHPR( bpid, army,  pos[1],pos[2],pos[3], 0,0,0)
				playBuildEffect(newunit)				
				newunit:GetBlueprint().Wreckage.WreckageLayers.Land=false
				newunit:SetReclaimable(false)
				
				--a turret will be able to shoot at air units
				--the original damage done by a turret is taken away and the new damage is added
				for i = 1, newunit:GetWeaponCount() do
					newunit:GetWeapon(i):SetFireTargetLayerCaps('AIR')
					setDamage(newunit:GetWeapon(i),turret.damage)
				end
				
				--add special abilities
				--slowdown ability
				if turret.slowdown then
					addSlowDown(newunit,turret.slowdown[1],turret.slowdown[2])
				end
				
				--poison ability
				if turret.poison then
					addPoison(newunit,turret.poison[1],turret.poison[2])
				end
				
				--turret name
				if turret.name then
					newunit:SetCustomName(turret.name)
				end
				
				--unit is invincible: problem, no ctrl-k
				makeInvincible(newunit)
				
				--take money
				SetArmyEconomy(army,-turret.price,0 )	

				--cancel original build order
				if unit then
					unit:OnFailedToBeBuilt()	
				end
				
				--acknowledge unit built
				unitbuilt = true		
			end
		end		

		KillThread(self)
	end)
	

end





--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~UNIT BEHAVIOUR CHANGE FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


--makes a unit invincible
makeInvincible = function(unit)
	unit:SetDoNotTarget(true)
	unit:SetCanBeKilled(false)
	unit:SetCapturable(false)
	unit:SetReclaimable(false)
	unit:SetRegenRate(1)
	unit:SetMaxHealth(1)
	unit:SetHealth(nil,1)
end

--unit killer gets income
addKillerIncome = function(unit,massincome,energyincome)
	unit.OldOnKilled = unit.OnKilled
	unit.OnKilled = function(self, instigator, type, overkillRatio)
		--give 5 mass income per kill
		if instigator then
			local player = players[armyTable[scnArmy(self)]]
			local killer = players[armyTable[scnArmy(instigator)]]
			SetArmyEconomy( toArmy(killer), massincome  , energyincome)	
			killer.kills = killer.kills + 1
			checkCredits(killer)
		end
		unit.OldOnKilled(self, instigator, type, overkillRatio)	
	end	
end

--give a credit to the player if necessary
checkCredits = function(player)
	local modulo = math.mod(player.kills,creditKillCost)
	if modulo == 0 then
		player.credits = player.credits + 1
	end
end

--unit hp will be set to lifetime and unit will lose one hp per second until it dies
makePerishable = function(unit,lifetime)
	--unit.OnDamage = function(self) WARN("LOL") end
	unit:SetMaxHealth(lifetime)
	local timeleft = lifetime
	local lifetimeThread = ForkThread(function(self)	
		for timeleft = lifetime,0,-1 do
			if unit and not unit:IsDead() then
				unit:SetHealth(nil,timeleft)
			end
			WaitSeconds(1)
		end
		if unit and not unit:IsDead() then
			unit:Kill()
		end
		KillThread(self)
	end)
end


--replaces the normal onfire sequence by a custom weapon firing pattern
--weapon hits instantly every time it shoots.
addInstaHit = function(instigator)
	local bp = instigator:GetBlueprint()
	local bpid = bp.BlueprintId
	local turret = getTurret(bpid)
	
	for i = 1, instigator:GetWeaponCount() do
		if not turret.weaponsfired or (turret.weaponsfired and i <= turret.weaponsfired) then	
			local weapon = instigator:GetWeapon(i)
			weapon.OnFire = function(weapon)	

				--play weapon sound
				local wbp = weapon:GetBlueprint()
		        if wbp.Audio.Fire then
		            weapon:PlaySound(wbp.Audio.Fire)
		        end
			
				--aquire target and convert to unit if target is a blip
				local target = weapon:GetCurrentTarget()
				if IsBlip(target) then target = target:GetSource() end
				
				if turret.area and turret.area != 0 then
				
					--if area damage, get units around point
					if GetArmyBrain(scnArmy(target)):GetUnitsAroundPoint(categories.MOBILE,target:GetPosition(), turret.area,'Ally') then
						local targetUnits = GetArmyBrain(scnArmy(target)):GetUnitsAroundPoint(categories.MOBILE,target:GetPosition(), turret.area,'Ally')
						if table.getsize(targetUnits) > 0 then
							for index,target in targetUnits do
								if turret.damage > 0 then
									--do damage
									Damage(instigator, target:GetPosition(), target, turret.damage, 'Normal')
								end
								--do custom unit abilities
								doAbilities(target,instigator)
							end
						end
					end
					
				else		
					if turret.damage > 0 then
						--do damage
						Damage(instigator, target:GetPosition(), target, turret.damage, 'Normal')
					end
					--do custom unit abilities
					doAbilities(target,instigator)
				end

				--weapon.OnLostTarget(weapon)
				

				
			end
		else
			weapon.OnFire = function(weapon) end
		end
	end
end

--do custom unit abilities such as freeze and poison
doAbilities = function(target,instigator)
	if target and instigator and not target:IsDead() and target.HasDamageCallbacks and target.HasDamageCallbacks == true then
		if instigator.slowdown then
			doSlowDown(target,instigator,instigator.slowdown.percent,instigator.slowdown.time)
		end
		if instigator.poison then
			doPoison(target,instigator.poison)
		end
	end
end

--add an ondamaged callback
addDamagedCallBack = function(unit)
	unit.HasDamageCallbacks = true 
end


--ad poisoning ability to unit
addPoison = function(unit,poisondamage,poisontime)
	unit.poison = {damage = poisondamage, time = poisontime}
	addInstaHit(unit)
end

--add slowdown ability to unit
addSlowDown = function(unit,slowdownpercent,slowtime)
	unit.slowdown = {percent = slowdownpercent, time = slowtime}
	addInstaHit(unit)
end



--poison a unit using a poison table containing damage persecond and poisoning time
poison = function(unit,poison,effects)	
	ForkThread(function()
		for timeleft = poison.time,0,-1 do
			WaitSeconds(1)
			if unit and not unit:IsDead() then
				if unit:GetHealth() > poison.damage then
					unit:AdjustHealth(nil, -poison.damage)
				else
					unit:SetHealth(nil,1)
				end
			end
		end
		if effects then
			for k,effect in effects do
				effect:Destroy()
			end
		end
	end)
end

--poison a unit with effects
doPoison = function(unit,poisontable)	
	local emittereffect = '/effects/emitters/aeon_chrono_dampener_04_emit.bp'
	local emitter = CreateAttachedEmitter(unit, unit:GetBoneName(0), unit:GetArmy(), emittereffect)	
	local effects = {emitter}
	
	poison(unit,poisontable,effects)
end

--slow down freezes a unit for a certain number of seconds by a certain percent of its speed. 
slowDown = function(unit,slowdownpercent,slowtime,effects)
	local slowdown
	if unit.originalSpeedmult then
		slowdown = unit.originalSpeedmult*(slowdownpercent/100)
	else
		slowdown = (slowdownpercent/100)
	end
	
	unit:SetSpeedMult(slowdown)
	ForkThread(function() 
		WaitSeconds(slowtime)	
		if unit and not unit:IsDead() then
			if effects then
				for k,effect in effects do
					effect:Destroy()
				end
			end
			if unit.originalSpeedmult then
				unit:SetSpeedMult(unit.originalSpeedmult)
			else
				unit:SetSpeedMult(1)
			end
		end
	end)
end


--slow down unit with beam effect
doSlowDown = function(unit,instigator,slowdownpercent,slowtime)
	local beameffect = '/effects/emitters/terran_transport_beam_01_emit.bp'
	local beameffect2 = '/effects/emitters/terran_transport_beam_02_emit.bp'
	--local emittereffect = '/effects/emitters/terran_transport_glow_01_emit.bp'

	local beam = AttachBeamEntityToEntity(unit, unit:GetBoneName(0), instigator, instigator:GetBoneName(0), instigator:GetArmy(), beameffect)
	local beam2 = AttachBeamEntityToEntity(unit, unit:GetBoneName(0), instigator, instigator:GetBoneName(0), instigator:GetArmy(), beameffect2)
	--local emitter = CreateEmitterAtBone( instigator, instigator:GetBoneName(0), instigator:GetArmy(), emittereffect)
	
	local effects = {beam,beam2}

	slowDown(unit,slowdownpercent,slowtime,effects)
end



--give to a unit the caracteristics of a builer unit
makeBuilder = function(player,unit)
		makeInvincible(unit)				
		addInstaBuild(unit)		

		unit:SetCustomName( "" .. username(player) .. " : builder")
		--unit:CreateEnhancement('T3Engineering')
		unit:SetAccMult(3)
		unit:SetTurnMult(4)
		unit:SetSpeedMult(4)
		unit:SetBuildRate(500)		
		unit:SetProductionPerSecondMass(0)
		unit:SetProductionPerSecondEnergy(5000)
		unit:SetConsumptionPerSecondEnergy(5)
		unit:SetConsumptionPerSecondMass(1)
		unit:SetConsumptionActive(false)
		unit:SetAllWeaponsEnabled(false)		
end



--play a nice build effect
playBuildEffect = function(unit)
	unit:PlayUnitSound('TeleportStart')
	unit:PlayUnitAmbientSound('TeleportLoop')
	WaitSeconds( 0.1 )
	unit:PlayTeleportInEffects()
	WaitSeconds( 0.1 ) 
    unit:StopUnitAmbientSound('TeleportLoop')
    unit:PlayUnitSound('TeleportEnd')
end














--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~MISCALENIOUS FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~




--SPECIAL ARMY INITIALISATION: CUSTOM ALLIANCES
function InitializeArmies()
    local tblGroups = {}
    local tblArmy = ListArmies()
	
	--determine the players depending on which slots are occupied
	for index,army in tblArmy do
		players[armyTable[army]] = playersDATA[armyTable[army]]
		ScenarioFramework.AddRestriction(army, categories.WALL)
	end
	
	--initialise armies
    for iArmy, strArmy in pairs(tblArmy) do
        local tblData = Scenario.Armies[strArmy]

        tblGroups[ strArmy ] = {}

        if tblData then
			
			AddBuildRestriction(iArmy,buildRestriction)
			--SetArmyEconomy( strArmy, tblData.Economy.mass, tblData.Economy.energy)

        end

    end

	--my function to initialise alliances
	initialiseAlliances()
	
	--GetArmyBrain('ARMY_9').civilian = false
	
    return tblGroups
end



--the defender is alone against the attackers
function initialiseAlliances()
	for index,army in ListArmies() do

		--a player is allied to everybody exept its direct enemy
		for index2,army2 in ListArmies() do
			--disable ressource sharing
			GetArmyBrain(army):SetResourceSharing(false)
			if toPlayer(army).ai == true then
				SetArmyColor(armyToIndex(army), toPlayer(army).color[1], toPlayer(army).color[2], toPlayer(army).color[3])			
			end
			--set alliances
			if toPlayer(army2).ai == toPlayer(army).ai then
				SetAlliance( army, army2, 'Ally')
			elseif toPlayer(army).name == 'enemy' then
				SetAlliance( army, army2, 'Enemy')
			else
				SetAlliance( army, army2, 'Ally')
			end
		end

	end
end

















--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~UTILITY FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--given a player returns an army
toArmy = function(player)
	local army = false
	for i,v in armyTable do
		if v == player.name then
			army = i
		end
	end
	return army
end


--given a player returns a proper username
username = function(player)
	return GetArmyBrain(toArmy(player)).Nickname
end

--given a player returns the number of kills
armyKills = function(player)
	local kills = 0
	if player.name != 'neutral' then 
		local army = toArmy(player)
		kills = GetArmyBrain(army):GetArmyStat('Enemies_Killed',0.0).Value 
	end
	return kills	
end

--print a text scn way :p
--first arg is the text to print
--second arg is what player it concerns
--third arg is if it has to be printed to that player only or to all players
scnPrint = function(text,player,playeronly)

	local army = toArmy(player)
	local colorIndex = ScenarioInfo.ArmySetup[army].PlayerColor
	local color = import('/lua/GameColors.lua').GameColors.ArmyColors[colorIndex]
	
	if not playeronly then
		playerspecific = false
	else
		playerspecific = playeronly
	end
	
	
	if playerspecific == true then
		if army == indexToArmy(GetFocusArmy()) then
			PrintText(text,20,color,5,'center') 
		end
	else
		PrintText(text,20,color,5,'center') 
	end
end

fastFocusPrint = function(text,player)
	local army = toArmy(player)
	if army == indexToArmy(GetFocusArmy()) then
		PrintText(text,20,nil,5,'center') 	
	end	
end

fastPrint = function(text)
	PrintText(text,20,nil,5,'center') 		
end

--given a unit returns the army
scnArmy = function(unit)
	local armyIndex = unit:GetArmy()
	return indexToArmy(armyIndex)
end

--given an army index returns an army
indexToArmy = function(armyIndex)
	local army = ListArmies()[armyIndex]
	return army
end

--given an army return its index
armyToIndex = function(army)
	for i,v in ListArmies() do
		if v == army then
			return i 
		end
	end
end

--get the number of players
playerCount = function()
	local i = 0
	for index, player in players do
		if player.ai == false then
			i = i + 1
		end
	end
	return i
end


--given an ai brain returns an army index
function ArmyIndexer(aiBrain)
	local tblArmy = ListArmies()
	local army = tblArmy[aiBrain:GetArmyIndex()]
	for i, v in armyTable do
		if i == army then
			return v
		end
	end
end

--given an army returns a player
function toPlayer(army)
	return players[armyTable[army]]
end

--given a player return the enemy
function enemy(player)
	return players[player.enemy]
end

--copy the map script variables into the aibrains so that the zone control ai can use them
copyPlayerInfo = function()
	for i, player in players do
		GetArmyBrain(toArmy(player)).SAODnfo = table.copy(players)
	end
end

--get marker given a name from map_save done in map editor, you can the use marker.position to get a location in the {x,y,z} format
function GetMarker(name)
    return Scenario.MasterChain._MASTERCHAIN_.Markers[name]
end

function mPos(name)
	return GetMarker(name).position
end

--given a marker return a rectangle
markerToRect = function(markername)
	local rectangle = {}
	local position = GetMarker(markername).position

	if not position then position = {0,0,0} end
	
	rectangle.x0 = position[1] - 25
	rectangle.y0 = position[3] - 25
	rectangle.x1 = position[1] + 25
	rectangle.y1 = position[3] + 25
	
	--special treatment for start and finish
	if markername == "Start" then
		rectangle.startarea = true
	elseif markername == "Finish" then
		rectangle.finalarea = true
	end
	
	return rectangle
end

--display a countdown
--call from within a thread
countDown = function(timeseconds)
	for timeleft = timeseconds,0,-1 do 
		Sync.ObjectiveTimer = timeleft
		WaitSeconds(1)
	end
end

--check if a player has enough money and if he has takes that money from him and returns true
--mass is used as money here
checkPrice = function(player,price,pricetype)
	local army = toArmy(player)
	local brain = GetArmyBrain(army)
			
	if pricetype then
		if pricetype == "credits" then
			if checkCreditPrice(player,price) then return true else return false end
		end
	else
		
		if brain:GetEconomyStored('MASS') >= price then	
			SetArmyEconomy(army,-price,0 )	
			return true
		else
			return false
		end
		
	end
end

checkCreditPrice = function(player,price)
	if player.credits >= price then	
		player.credits = player.credits - price
		return true
	else
		return false
	end
end

--play a nice effect on a unit
spawnEffect = function(unit)
	unit:PlayTeleportInEffects()
end



--all rock and tress on the map will not be reclaimable
allReclaimablesOFF = function()
	entities = GetEntitiesInRect(mapRect)
	reclaimables = {}
	for i,ent in entities do
		if (ent.MassReclaim and ent.MassReclaim > 0) or (ent.EnergyReclaim and ent.EnergyReclaim > 0) then
			table.insert(reclaimables,ent)
		end
	end
	if reclaimables and table.getn(reclaimables) then
		for i,ent in reclaimables do
			ent.MassReclaim = 0
			ent.EnergyReclaim = 0
		end
	end
end

--simple function to set the damage of a weapon
setDamage = function(weapon,value)
	local bp = weapon:GetBlueprint()
	weapon.DamageMod = 0
	weapon:AddDamageMod(-bp.Damage)
	weapon:AddDamageMod(value)
end


-- OnFreeze = function(self, target_unit)
	-- EffectUtilities.PlaySacrificingEffects(self,target_unit)
	-- EffectUtilities.PlaySacrificeEffects(self,target_unit)
-- end



